/********************************************
*	FUNCTION	: Piezo Functions
*	MODEL		: CM31 
*	CPU	NAME	: S3C2416
*	SOURCE		: piezo.c
*	DEVISION	: DEPT. H/W TEAM
*			: ASITEQ, INC.  
*********************************************/

#include <common.h>
#include <s3c2416.h>
static void mdelay(uint32_t msecs)
{
		while (msecs) {
				udelay(1000);
				msecs--;
		}
}


void piezo_set(unsigned int volume,unsigned int freq)
{
	unsigned long tcfg0,tcfg1,tcon=0;
	
		GPBCON_REG |= (0x2<<2);	
		GPBPU_REG |= (0x2<<2);	
//		if((freq>2750) && (freq<16500))printf("freq error range 2750(6K)~16500(1K)val input\n");
		tcfg0 = TCFG0_REG;
		tcfg1 = TCFG1_REG;
		
		tcfg0 &= ~(255<<0);
		tcfg0 |= 166<<0;
		tcfg1 &= ~(0xf<4);
		tcfg1 |= (0x0<<4);
		
		
		TCFG0_REG = tcfg0;
		TCFG1_REG = tcfg1; 
		tcon  = TCON_REG;
		
		TCNTB1_REG = 100;
		TCMPB1_REG = volume;
		
		tcon |= (1<<9) | (1<<11);
		TCON_REG = tcon;
		
		tcon &=~(1<<9) ;
		TCON_REG = tcon;
		
		
		tcon |= (1<<8) ;
		TCON_REG = tcon;
}
