/*
 * $Id: nand_cp.c,v 1.2 2008/04/14 01:32:57 boyko Exp $
 *
 * (C) Copyright 2006 Samsung Electronics
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

/*
 * You must make sure that all functions in this file are designed
 * to load only U-Boot image.
 *
 * So, DO NOT USE in common read.
 *
 * By scsuh.
 */


#include <common.h>

#if CONFIG_S3C24XX
#include <asm/io.h>
#include <linux/mtd/nand.h>
#include <regs.h>

#ifdef CONFIG_NAND_BL1_8BIT_ECC
#define USE_BL1_8BIT_ECC
#endif

#ifdef USE_BL1_8BIT_ECC 
static inline void nandll_print_char(char d)
{
	UTXH0_REG = d;
	while (!(UTRSTAT0_REG & 0x4)) ;
}

static void print_hex(unsigned char nibble)
{
	if (nibble < 10)
		nandll_print_char('0'+nibble);
	else
		nandll_print_char('A'+nibble-10);
}

static void print_data(unsigned char data)
{
	print_hex((data >> 4) & 0xf);
	print_hex((data >> 0) & 0xf);
}

void check_first_steppingstone(void)
{
	volatile unsigned long i;
	volatile unsigned long did;

	for (i=0; i<20000; i++);//minmum 100us delay
	NF_TRANSRnB();

	NAND_ENABLE_CE();
	NFCMD_REG = NAND_CMD_RESET;
	NF_TRANSRnB();

	NFCMD_REG = NAND_CMD_READID;
	NFADDR_REG = 0x00;

	/* wait for a while */
    for (i=0; i<200; i++);

	/* manufacture id */
	i = NFDATA8_REG;
	if (i == 0xAD) {	/* HYNIX */
		/* device code */
		i = NFDATA8_REG;
	    	if( i != 0xD7 && i != 0xD5)
		    return;
		did = NFDATA8_REG;
		did = NFDATA8_REG;
		if (did != 0x9a)
			return;
	} else
		return;

	NFCMD_REG = NAND_CMD_READ0;
	NFADDR_REG = 0x00;
	NFADDR_REG = 0x10;

	NFADDR_REG = 0x00;
    NFADDR_REG = 0x00;
    NFADDR_REG = 0x00;

	NFCMD_REG = NAND_CMD_READSTART;

    NF_TRANSRnB();

#if 0
	nandll_print_char('\r');
	nandll_print_char('\n');
#endif
	for(i=4096; i < 8192; i++) {
		*((unsigned char *)(i)) = NFDATA8_REG;
//		print_data(*((unsigned char *)(i)));
	}
#if 0
	nandll_print_char('\r');
	nandll_print_char('\n');
#endif

	NAND_DISABLE_CE();
}

#endif
#endif
